/*
 * CLIPS Facts parser
 */
%{
  open Facts
%}

%token <int> INT
%token <float> FLOAT
%token <string> IDENT
%token <string> OID
%token <string> ASSOC
%token LP RP
%token MINUS UMINUS
%token EOF
%left  MINUS
%nonassoc UMINUS

%start root
%type <Facts.expr list> root
%type <int> integer
%type <float> float
%%

root: expr_list EOF   { $1 }
;

expr: IDENT                         { Facts.IDENT($1) }
    | LP ASSOC IDENT IDENT RP       { Facts.ASSOC($2,$3,$4) }
    | LP IDENT expr_list RP         { Facts.FACT($2,$3) }
    | integer                       { Facts.INT($1)   }
    | float                         { Facts.FLOAT($1) }
    | OID                           { Facts.OID($1)   }
;

integer: INT                      { $1   }
  | MINUS INT %prec UMINUS        { - $2 }
;

float: FLOAT                      { $1   }
  | MINUS FLOAT %prec UMINUS      { -. $2 }
;

expr_list: /**/                   { []     }
         | expr expr_list         { $1::$2 }
