module OrderedString = struct
   type t = string
   let compare = compare
end
module StringMap = Map.Make(OrderedString)
module StringSet = Set.Make(OrderedString)

module OrderedStringString = struct
   type t = string*string
   let compare = compare
end
module StringStringMap = Map.Make(OrderedStringString)
module StringStringSet = Set.Make(OrderedStringString)

module OrderedStringStringString = struct
   type t = string*string*string
   let compare = compare
end
module StringStringStringMap = Map.Make(OrderedStringStringString)

module OrderedStringStringStringId = struct
   type t = string*string*string*int
   let compare = compare
end
module StringStringStringIdMap = Map.Make(OrderedStringStringStringId)

module OrderedId = struct
   type t = int
   let compare = compare
end
module IdMap = Map.Make(OrderedId)
module IdSet = Set.Make(OrderedId)

module OrderedDate = struct
   type t = Date.date
   let compare = compare
end
module DateMap = Map.Make(OrderedDate)

module OrderedIdDate = struct
   type t = int * Date.date
   let compare = compare
end
module IdDateMap = Map.Make(OrderedIdDate)

module OrderedStringId = struct
   type t = string * int
   let compare = compare
end
module StringIdMap = Map.Make(OrderedStringId)

module OrderedStringDate = struct
   type t = string * Date.date
   let compare = compare
end
module StringDateMap = Map.Make(OrderedStringDate)

module OrderedFloat = struct
   type t = float
   let compare = compare
end
module FloatMap = Map.Make(OrderedFloat)
